<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "TagCloud"					                         |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1a / November 2013 ==

*/

if (!defined('CPO')) exit;
$translator->addTranslation('tagcloud', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['TagCloud'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'TagCloud',
    'install'   => 'function: TagCloud_install '.$moduleDirectory,
    'activate'  => 'function: TagCloud_activate '.$moduleDirectory,
    'deactivate'=> 'function: TagCloud_deactivate',
    'uninstall' => 'function: TagCloud_uninstall '.$moduleDirectory,
    'manage'	=> 'function: TagCloud_manage',
	'owner'		=> $cpoSystem['owner'],
	'lkey'		=> '',
	'mod_id'	=> 22,
	'helptoc'	=> array(
		'bersicht' 
			=> 'http://manual.conpresso4.de/tagcloud/index.htm',
		'1. Was macht das Modul "TagCloud"?' 
			=> 'http://manual.conpresso4.de/tagcloud/features.htm',
		'2. Installation' 
			=> 'http://manual.conpresso4.de/tagcloud/setup.htm',
		'3. Einstellungen' 
			=> 'http://manual.conpresso4.de/tagcloud/settings.htm',
		'4. Anwendung' 
			=> 'http://manual.conpresso4.de/tagcloud/application.htm'
	),
	'externalHelpUrl'	=> 'http://manual.conpresso4.de',
	// presets
	'tagcontent'		=> 'yes',
	'tagkeywords'		=> 'yes',
	'tagtitles'			=> 'yes',
	'minCountValue'		=> 5,
    'minWordLen'		=> 4,
    'maxWordLen'		=> 25,
    'maxWordCount'		=> 50,
    'chooseItemStyle'	=> 1,
    'modSearchDir'		=> 'mod_search',
    'exclude_words'		=> 'mit, ab, aber, abgesehen, alle, allein, aller, alles, als, am, an, aus, andere, anderen, anderenfalls, anderer, anderes, anstatt, auch, auf, aussen, ausser, auer, ausserdem, ausserhalb, behalten, bei, beide, beiden, beider, beides, beim, beinahe, bevor, bist, bitte, daher, danach, dann, darueber, darber, darueberhinaus, darum, das, dass, da, dem, den, der, des, deine, deshalb, die, diese, diesem, diesen, dieser, dieses, dort, du, dich, duerfte, duerften, duerftest, duerftet, durch, durfte, durften, durftest, durftet, ein, eine, einem, einen, einer, eines, einige, einiger, einiges, entgegen, entweder, erscheinen, es, etwas, fast, fertig, fort, fuer, gegen, gegenueber, gehalten, geht, gemacht, gemaess, genug, gerne, getan, getrennt, gewesen, gibt, gruendlich, hab, habe, haben, habt, haeufig, hast, hat, hatte, hatten, hattest, hattet, hier, hindurch, hintendran, hinter, hinunter, ich, ihm, ihnen, ihr, ihre, ihrem, ihren, ihrer, ihres, ihrige, ihrigen, ihriges, im, immer, ins, in, indem, innerhalb, innerlich, irgendetwas, irgendwelche, irgendwenn, irgendwo, irgendwohin, ist, jede, jedem, jeden, jeder, jedes, jedoch, jemals, jemand, jemandem, jemanden, jemandes, jene, jetzt, jung, junge, jungem, jungen, junger, junges, kann, kannst, kaum, kein, keine, koennen, koennt, koennte, koennten, koenntest, koenntet, konnte, konnten, konntest, konntet, mache, machen, macht, machte, mehr, mehrere, mein, meine, meinem, meinen, meiner, meines, meistens, mich, mir, mit, muessen, muesst, muss, musst, nach, nachdem, naechste, nchste, nebenan, nein, nichts, niemand, niemandem, iemanden, niemandes, nirgendwo, nur, oben, obwohl, oder, oft, ohne, per, sagte, sagten, sagtest, sagtet, scheinen, sehr, seid, seien, seiest, seiet, sein, seine, seinem, seinen, seiner, seines, seit, selbst, sich, sie, sind, so, sogar, solche, solchem, solchen, solcher, solches, sollte, sollten, solltest, solltet, sondern, statt, stets, tatsaechlich, tief, tun, ueber, ber, ueberall, um, und, uns, unser, unsere, unserem, unseren, unserer, unseres, unten, unter, unterhalb, usw, viel, viele, vielleicht, vom, von, vorbei, vorher, vorueber, waehrend, wann, waren, warst, wart, weder, wegen, weil, weit, weiter, weitere, weiterem, weiteren, weiterer, weiteres, welche, welchem, welchen, welcher, welches, wem, wen, wenige, wenn, werde, wer, werden, werdet, wessen, wie, wieder, wir, wird, wirklich, wirst, wo, wohin, wuerde, wuerden, wuerdest, wuerdet, wurde, wurden, wurdest, wurdet, ziemlich, zu, zum, zur, zusammen, zwischen, nicht, 2007, 2009, 2010, 2011, 2012, 2013, 2014, 2015',
	'CSS'				=> '#tagcloud {
	/* der Rahmen */
	width: 300px;
	background: #FBFBF4;
	padding: 4px;
	border: 1px solid #CCCCCC;
	/* der Text */
	text-align:center;
	font-size: 8px;
	font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;
	line-height:12px;
	text-transform: uppercase;
}
/* die Links */
#tagcloud a:link, #tagcloud a:visited {
	text-decoration:none;
	padding: 4px;
}
#tagcloud a:hover, #tagcloud a:active {
	text-decoration: none;
	color: white;
	background: #AF1E2D;
}
/* die berschriften-Tags */
#tagcloud * { display:inline; }
#tagcloud h1, #tagcloud h1 a:link, #tagcloud h1 a:visited { font-size: 14px; color:#000; }
#tagcloud h2, #tagcloud h2 a:link, #tagcloud h2 a:visited { font-size: 12px; color:#222; }
#tagcloud h3, #tagcloud h3 a:link, #tagcloud h3 a:visited { font-size: 11px; color:#444; }
#tagcloud h4, #tagcloud h4 a:link, #tagcloud h4 a:visited { font-size: 10px; color:#666; }
#tagcloud h5, #tagcloud h5 a:link, #tagcloud h5 a:visited { font-size:  9px; color:#999; }
#tagcloud h6, #tagcloud h6 a:link, #tagcloud h6 a:visited { font-size:  8px; color:#CCC; }
'
	);

function TagCloud_install($moduleDirectory)
{
	$mdb = new DB;
	$mdb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('TagCloud', '".serialize(array("installed"=>time()))."', '') ");
    $GLOBALS['message'][] = __('The tagcloud module was successfully installed!');
	log_TagCloud();
}
function TagCloud_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The tagcloud module was removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the tagcloud-module.'),$moduleDirectory);

}
function TagCloud_activate($moduleDirectory)
{
    $GLOBALS['message'][] = __('The tagcloud module got activated.');
}

function TagCloud_deactivate()
{
    $GLOBALS['message'][] = __('The tagcloud module got deactivated.');
}

function log_TagCloud()
{
	global $cpoSystem;
	@mail('kontakt@conpresso4.de','Das Modul TagCloud 4.1a wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
}

function TagCloud_manage()
{
	global $dbPrefix, $db, $k, $module_status, $newsletter_rubric_id;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['TagCloud']['directory'].'/settings.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('TagCloud settings').'" alt="'.__('TagCloud settings').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}

if (!$activeModules['TagCloud']['installed'])  {
    $mdtc = new DB;
    $mdtc->query('SELECT options FROM '.CPO_OPTION.' '
              ."WHERE type='TagCloud' ORDER BY id ASC LIMIT 0,1");
    while ($mdtc->next_record()) {
        $options = $mdtc->v('options');
        $tagcloudOpt = unserialize($options);
        if (!is_array($tagcloudOpt)) break;
        foreach ($tagcloudOpt as $key=>$v) {
            $activeModules['TagCloud'][$key] = $v;
        }
    }
}

if (	license($activeModules['TagCloud']['lkey'],$activeModules['TagCloud']['mod_id']) != 3 &&
		license($activeModules['TagCloud']['lkey'],$activeModules['TagCloud']['mod_id']) != 1 &&
		$activeModules['TagCloud']['installed']<(time()-90*24*60*60) && 
		!isset($_POST['go']) &&
		@file_exists(CPO_BASEDIR.$activeModules['TagCloud']['directory'].'/producer.inc.php')
	) 
	{
	if (@file_exists(CPO_BASEDIR.$activeModules['TagCloud']['directory'].'/producer.inc.php')) include(CPO_BASEDIR.$activeModules['TagCloud']['directory'].'/producer.inc.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	$tcbreak = true;
}

if (!$tcbreak) {
    include(CPO_BASEDIR.$moduleDirectory.'/mod_tagclouds.inc.php');
    // the PHP-Function
	function modTagCloud()        { echo   getTagCloud(); }
	// the CPO4.1 PageTemplate-Functions <!-- function: modTagCloud; -->
	function cpoPageModTagCloud() { return getTagCloud(); }
}

?>