<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "TagCloud"                                            |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1a / November 2013 ==

*/

function getTagCloud() {

    global $activeModules,$cpoRubric;

    $tagcloud_output = '';

    if (trim($activeModules['TagCloud']['CSS']) != '') $tagcloud_css .= "<style type=\"text/css\">\n".$activeModules['TagCloud']['CSS']."\n</style>\n";

    $tagcontent = $activeModules['TagCloud']['tagcontent'];
    $tagkeywords = $activeModules['TagCloud']['tagkeywords'];
    $tagtitles = $activeModules['TagCloud']['tagtitles'];

    $minCountValue = $activeModules['TagCloud']['minCountValue'];
    $minWordLen = $activeModules['TagCloud']['minWordLen'];
    $maxWordLen = $activeModules['TagCloud']['maxWordLen'];
    $exclude_words = $activeModules['TagCloud']['exclude_words'];
    $exclude_words = str_replace (chr(10), "", $exclude_words); 
    $exclude_words = str_replace (chr(13), "", $exclude_words);
    $maxWordCount = max(1, $activeModules['TagCloud']['maxWordCount']);
    $chooseItemStyle = $activeModules['TagCloud']['chooseItemStyle'];
    $rubricName = $cpoRubric['name'];

    $modSearchDir = $activeModules['TagCloud']['modSearchDir'];

//    global $modSearchDir;

    function exclude($exclude_words)
        {
             $exclude_words = clean_tagstring($exclude_words);
             $exclude_words = explode (' ', strtolower ($exclude_words) );
        return $exclude_words;
        }

    function clean_tagstring($string='')
    {
        $expr = '/<.*>(.*)<\/.*>/i';
        $string = str_replace($expr, ' $1 ', $string);

        $string = strip_tags($string); 

        $string = str_replace("\0"  , "" , $string);  
        $string = str_replace("\x0B", "" , $string);  

        $umlauteHTML = array ( '&amp', '&szlig;', '&nbsp;', '&uuml;', '&Uuml;', '&auml;', '&Auml;', '&ouml;', '&Ouml;' );
        $umlauteREAL = array ( '&',      '',       ' ',      '',      '',      '',      '',      '',      ''      );
        $string = str_replace($umlauteHTML, $umlauteREAL, $string);  

        $sonderzeichen = array ( "\r\n", "\r", "\n", "\t", '.', ':', ',', ';', '-', '+', '!', '\"', '\'', '$', '&', '/', '(', ')', '=', '?', '"', '@', '#', '_', '<', '>', '  ', '*', '', '`', '^', '[', ']', '}', '{', '', '');

        $string = str_replace($sonderzeichen, ' ', $string);

        $string = trim ($string);

        return $string;
    }

       function build_tags_array($tagclouds,$exclude_words,$minCountValue,$minWordLen,$maxWordLen)
       {
          if (empty ($tagclouds))
             return array ();
          else
          {
             $array_content = explode (' ', $tagclouds);
             $array_content = array_count_values ($array_content);
             $zb = 1;
             foreach ($array_content as $word => $count)
             {
                if ($count > $minCountValue
                    && strlen ($word) > $minWordLen
                    && strlen ($word) < $maxWordLen
                    && (!in_array (strtolower ($word), $exclude_words))
                   )
                {
                $zb++;
                $tags[$word] = $count;
                }
                unset ($count, $array_content[$word]);
             }
             if ($zb > 2) {
             ksort ($tags);
             }
          }
          return $tags;
       }

       function build_output($tags,$modSearchDir,$rubricName)
       {
            if (!is_array ($tags) || empty ($tags))
          {
             $output = '';
          }
          else
          {
            $multiplier = 6 / max ($tags);
    //		 print_r ($tags);
            foreach ($tags as $word => $count)
            {
                $word2 = rawurlencode($word);
                $headingsize = 7 - ceil( $multiplier * $count );
                $output .= '<h'.$headingsize.'><a title="'.$word.'" href="../'.$modSearchDir.'/index.php?action=search&q='.$word2.'&rubric='.$rubricName.'">'.$word.'</a> </h'.$headingsize.'>'."\n";
            }
        }
        return  $output;
       }
     
     
    $pub_datum     = "AND pub_datum<='".date('Y-m-d H:i:s')."' ";
    $verfallsdatum = "AND verfallsdatum>'".date('Y-m-d H:i:s')."' ";

    // Die Freigabe
    $freigabe = 'AND '.($cpoSystem['release'] 
                ? 'artikel_archiv<2 AND freigabe='.STATE_RELEASED.' ' 
                : 'artikel_archiv<1 AND freigabe!='.STATE_BLOCKED.' ');


    // Rubrikeneinschrnkung
//    print_r ($activeModules);
    $qrubrics = '';
    if (isset($activeModules[$modSearchDir]['rubrics']) && $activeModules[$modSearchDir]['rubricsUse'] != 'off') {
        $qrubrics = 'AND '.CPO_NEWS.'.rubric_id '.$activeModules[$modSearchDir]['rubricsUse'].' ('
                    . implode (', ', $activeModules[$modSearchDir]['rubrics']) . ') ';
    }
    if (!isset($activeModules[$modSearchDir]['rubrics']) 
        && $activeModules[$modSearchDir]['rubricsUse'] != 'off') {
        $qrubrics = 'AND '.CPO_NEWS.'.rubric_id '.$activeModules[$modSearchDir]['rubricsUse'].' (0)';
    }

    // geschlossene Rubriken und personalisierte Artikel, die der User sehen darf
    $sec_rubrics .= 'AND (seclevel=0';

    $db_sec = new DB;
    $query = 'SELECT rubric_id FROM '.CPO_RUBRIC_PERMISSION.' '
            ."WHERE usergroups_id='".addslashes($_SESSION['SID_user']['usergroups_id'])."'";
    $db_sec->query($query);
    if ($db_sec->num_rows()>0)  {
        $sec_rubrics .= ' OR '.CPO_NEWS.'.rubric_id IN (';
        $c = '';
        while ($db_sec->next_record())  {
            $sec_rubrics .= $c.(int)$db_sec->v('rubric_id');
            $c = ', ';
        }
        $sec_rubrics .= ')';
    }

    if ($_SESSION['SID_user']['usergroups_id']>0) {
        $sec_rubrics .= " OR auth LIKE '%#".$_SESSION['SID_user']['usergroups_id']."#%'";  
    }

    $sec_rubrics .= ') ';


    $tagclouds = '';
    $db_tagcloud = new DB;

    if ($tagcontent == 'yes') {
            $query = 'SELECT text FROM '.CPO_CONTENT_TEXT.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                    .'WHERE '.CPO_CONTENT_TEXT.'.article_id = '.CPO_NEWS.'.nr '
                    .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                    .$permission
                    .$freigabe
                    .$pub_datum
                    .$verfallsdatum
                    .$sec_rubrics
                    .$lastChangedBy
                    .$qrubrics;
            $db_tagcloud->query($query);
    //		echo $query.'<br /><br />';
            while ($db_tagcloud->next_record()) {
                $tagclouds .= ' '.$db_tagcloud->v('text');
            } // }}}

            $query = 'SELECT html FROM '.CPO_CONTENT_HTML.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                    .'WHERE '.CPO_CONTENT_HTML.'.article_id = '.CPO_NEWS.'.nr '
                    .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                    .$permission
                    .$freigabe
                    .$pub_datum
                    .$verfallsdatum
                    .$sec_rubrics
                    .$lastChangedBy
                    .$qrubrics;
            $db_tagcloud->query($query);
    //		echo $query.'<br /><br />';
            while ($db_tagcloud->next_record()) {
                $tagclouds .= ' '.$db_tagcloud->v('html');
            } // }}}
    }
    if($tagkeywords == 'yes') {
            $query = 'SELECT keywords FROM '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                    .'WHERE '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                    .$permission
                    .$freigabe
                    .$pub_datum
                    .$verfallsdatum
                    .$sec_rubrics
                    .$lastChangedBy
                    .$qrubrics;
            $db_tagcloud->query($query);
    //		echo $query.'<br /><br />';
            while ($db_tagcloud->next_record()) {
                $tagclouds .= ' '.$db_tagcloud->v('keywords');
            } // }}}
    }
    if($tagtitles == 'yes') {
            $query = 'SELECT titel FROM '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                    .'WHERE '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                    .$permission
                    .$freigabe
                    .$pub_datum
                    .$verfallsdatum
                    .$sec_rubrics
                    .$lastChangedBy
                    .$qrubrics;
            $db_tagcloud->query($query);
    //		echo $query.'<br /><br />';
            while ($db_tagcloud->next_record()) {
                $tagclouds .= ' '.$db_tagcloud->v('titel');
            } // }}}
    }





    $exclude_words = exclude($exclude_words); // macht aus dem Komma-String ein Array
    $tagclouds = clean_tagstring($tagclouds); // reduziert auf leerzeichengetrennte Wrter
    // echo '<br><br>'.$tagclouds.'<br><br>';
    $tags = build_tags_array($tagclouds,$exclude_words,$minCountValue,$minWordLen,$maxWordLen); // erstellt aus dem String ein Array mit Anzahl

    $maxWordCount = min($maxWordCount, count($tags));

    switch($chooseItemStyle) {
        case "2": //alphabetisch (bei A beginnend)
            reset($tags);
            while(list($word, $count) = each($tags)) {
                if ($tagcloud_i==$maxWordCount) {
                    break;
                }
                $tagcloud_i++;
                $t2[$word] = $count;
            }
        break;
        case "3": //alphabetisch (bei Z beginnend, rckwrts)
            end($tags);
            while ($count = current($tags)) {
                if ($tagcloud_i==$maxWordCount) {
                    break;
                }
                $tagcloud_i++;
                $t2[key($tags)] = $count;
                prev($tags);
            }
        break;
        case "4": //grte Hufigkeit
            arsort ($tags);
            while(list($word, $count) = each($tags)) {
                if ($tagcloud_i==$maxWordCount) {
                    break;
                }
                $tagcloud_i++;
                $t2[$word] = $count;
            }
        break;
        case "5": //geringste Hufigkeit
            asort ($tags);
            while(list($word, $count) = each($tags)) {
                if ($tagcloud_i==$maxWordCount) {
                    break;
                }
                $tagcloud_i++;
                $t2[$word] = $count;
            }
        break;
        default: // Zufall
            $temp = array_keys($tags);
            shuffle($temp);
            for($tagcloud_i=0;$tagcloud_i<$maxWordCount;$tagcloud_i++) {
                $t2[$temp[$tagcloud_i]] = $tags[$temp[$tagcloud_i]];
            }
        break;
    }
    $tags = $t2;
    unset($t2);
    unset($temp);


    $tagcloud_output .= build_output($tags,$modSearchDir,$rubricName);

    $tagcloud = "\n\n" . $tagcloud_css . "\n\n".'<div id="tagcloud">'."\n" . $tagcloud_output . '</div>'."\n\n";

    return $tagcloud;
}
?>